// XBaseTypes.h:
// -------------------------------------------------------------------
// This file is a part of "XTL" available at:
// http://www.codecommunity.com
//
// XTL is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License,
// or (at your option) any later version.
// 
// XTL is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
// License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with XTL. If not, see <http://www.gnu.org/licenses/>.
//
// coded by: skulk@codecommunity.com
// modified: 2006-09-02 (skulk)
//////////////////////////////////////////////////////////////////////
#ifdef X_WINDOWS
	#pragma once
	#include <windows.h>
#else // X_WINDOWS
	#error "Missing definition..."
#endif



// #######################################################################################



// ***************************************************************************************
// xvoid...
// ***************************************************************************************
typedef void						xvoid;
typedef const void					xcvoid;



// #######################################################################################



// ***************************************************************************************
// xbool...
// ***************************************************************************************
typedef bool						xbool;
typedef const xbool					xcbool;



// #######################################################################################



// ***************************************************************************************
// xint32...
// ***************************************************************************************
typedef int							xint32;
typedef const xint32				xcint32;



// #######################################################################################



// ***************************************************************************************
// xuint32...
// ***************************************************************************************
typedef unsigned int				xuint32;
typedef const xuint32				xcuint32;



// #######################################################################################



// ***************************************************************************************
// xint64...
// ***************************************************************************************
#ifdef X_WINDOWS
	typedef __int64					xint64;
	typedef const xint64			xcint64;
#else // X_WINDOWS
	#error "Missing definition..."
#endif



// #######################################################################################



// ***************************************************************************************
// xuint64...
// ***************************************************************************************
#ifdef X_WINDOWS
	typedef unsigned __int64		xuint64;
	typedef const xuint64			xcuint64;
#else // X_WINDOWS
	#error "Missing definition..."
#endif



// #######################################################################################



// ***************************************************************************************
// xshort...
// ***************************************************************************************
typedef short						xshort;
typedef const xshort				xcshort;



// #######################################################################################



// ***************************************************************************************
// xushort...
// ***************************************************************************************
typedef unsigned short				xushort;
typedef const xushort				xcushort;



// #######################################################################################



// ***************************************************************************************
// xword...
// ***************************************************************************************
typedef xushort						xword;
typedef xcushort					xcword;



// #######################################################################################



// ***************************************************************************************
// xlong...
// ***************************************************************************************
typedef long						xlong;
typedef const xlong					xclong;



// #######################################################################################



// ***************************************************************************************
// xulong...
// ***************************************************************************************
typedef unsigned long				xulong;
typedef const xulong				xculong;



// #######################################################################################



// ***************************************************************************************
// xdword...
// ***************************************************************************************
typedef xulong						xdword;
typedef xculong						xcdword;



// #######################################################################################



// ***************************************************************************************
// xfloat...
// ***************************************************************************************
typedef float						xfloat;
typedef const float					xcfloat;



// #######################################################################################



// ***************************************************************************************
// xdouble...
// ***************************************************************************************
typedef double						xdouble;
typedef const xdouble				xcdouble;



// #######################################################################################



// ***************************************************************************************
// xchara...
// ***************************************************************************************
typedef char						xchara;
typedef const xchara				xcchara;



// #######################################################################################



// ***************************************************************************************
// xuchara...
// ***************************************************************************************
typedef unsigned char				xuchara;
typedef const xuchara				xcuchara;



// #######################################################################################



// ***************************************************************************************
// xbyte...
// ***************************************************************************************
typedef xuchara						xbyte;
typedef xcuchara					xcbyte;



// #######################################################################################



// ***************************************************************************************
// xcharw...
// ***************************************************************************************
#ifdef X_WINDOWS
	typedef wchar_t					xcharw;
	typedef const xcharw			xccharw;
#else // X_WINDOWS
	typedef unsigned short			xcharw;
	typedef const xcharw			xccharw;
#endif

	
	
// #######################################################################################

	
	
// ***************************************************************************************
// xucharw...
// ***************************************************************************************
typedef xcharw						xucharw;
typedef xccharw						xcucharw;



// #######################################################################################



// ***************************************************************************************
// xchari...
// ***************************************************************************************
#ifdef X_WINDOWS
	typedef xcharw					xchari;
	typedef xccharw					xcchari;
#else // X_WINDOWS
	#error "Missing definition..."
#endif


// #######################################################################################



// ***************************************************************************************
// xchart...
// ***************************************************************************************
#ifdef X_UNICODE
	typedef xcharw					xchart;
	typedef xccharw					xcchart;
#else // X_UNICODE
	typedef xchara					xchart;
	typedef xcchara					xcchart;
#endif

	
	
// #######################################################################################



// ***************************************************************************************
// xuchart...
// ***************************************************************************************
#ifdef X_UNICODE
	typedef xucharw					xuchart;
	typedef xcucharw				xcuchart;
#else // X_UNICODE
	typedef xuchara					xuchart;
	typedef xcuchara				xcuchart;
#endif



// #######################################################################################



// ***************************************************************************************
// pointer values (xintptr)...
// ***************************************************************************************
#ifdef X_WINDOWS
	#ifdef WIN32
		typedef xint32				xintptr;
		typedef const xint32		xcintptr;
	#elif _WIN64 // WIN32
		typedef xint64				xintptr;
		typedef const xint64		xcintptr;
	#endif // _WIN64
#else // X_WINDOWS
	#error "Missing definition..."
#endif



// #######################################################################################



// ***************************************************************************************
// pointer values (xuintptr)...
// ***************************************************************************************
#ifdef X_WINDOWS
	#ifdef WIN32
		typedef xuint32				xuintptr;
		typedef const xuint32		xcuintptr;
	#elif _WIN64 // WIN32
		typedef xuint64				xuintptr;
		typedef const xuint64		xcuintptr;
	#endif // _WIN64
#else // X_WINDOWS
	#error "Missing definition..."
#endif



// #######################################################################################

	
	
// ***************************************************************************************
// pointer values (xlongptr)...
// ***************************************************************************************
typedef xlong						xlongptr;
typedef const xlong					xclongptr;



// #######################################################################################



// ***************************************************************************************
// pointer values (xulongptr)...
// ***************************************************************************************
typedef xulong						xulongptr;
typedef const xulong				xculongptr;



// #######################################################################################



// ***************************************************************************************
// pointer values (xdwordptr)...
// ***************************************************************************************
typedef xulongptr					xdwordptr;
typedef xculongptr					xcdwordptr;



// #######################################################################################



// ***************************************************************************************
// xresult...
// ***************************************************************************************
typedef xlong						xresult;
typedef const xresult				xcresult;



// #######################################################################################



// ***************************************************************************************
// xtime...
// ***************************************************************************************
#ifdef X_WINDOWS
	typedef time_t					xtime;
	typedef const time_t			xctime;
#else // X_WINDOWS
	#error "Missing definition..."
#endif



// #######################################################################################



// ***************************************************************************************
// xtimefile...
// ***************************************************************************************
#ifdef X_WINDOWS
	typedef FILETIME				xtimefile;
	typedef const FILETIME			xctimefile;
#else // X_WINDOWS
	#error "Missing definition..."
#endif



// #######################################################################################



// ***************************************************************************************
// xtimesystem...
// ***************************************************************************************
#ifdef X_WINDOWS
	typedef SYSTEMTIME				xtimesystem;
	typedef const SYSTEMTIME		xctimesystem;
#else // X_WINDOWS
	#error "Missing definition..."
#endif



// #######################################################################################



// ***************************************************************************************
// _xguid...
// ***************************************************************************************
struct _xguid
{
	xulong ulData1;
	xushort usData2;
	xushort usData3;
	xuchart ucData4[8];
};

typedef _xguid						xguid;
typedef const xguid					xcguid;



// #######################################################################################



// ***************************************************************************************
// __xvoid...
// ***************************************************************************************
typedef struct __xvoid
{
// Intentionally a void object...
} _xvoid;

typedef const _xvoid				_xcvoid;



// #######################################################################################
